<template>
  <div>
     <header style="margin:10rem 6rem 3rem 6rem">
        <ReturnButton  :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="modalReturnBtn = true" > </ReturnButton>
     </header>
    <section style="margin:0rem 10rem 5rem 10rem">   
       <!--TITULO  -->
       <div class="bg-gray-suave" style="padding:10px 20px">
          <h3 class="text-white bolt-light"> NUEVO PEDIDO </h3>
        </div>
        <div  style="margin: 2rem 3rem 6rem">
          <h4 style="margin: 5rem 0 0" class="text-orange">FECHA DE PEDIDO Y ENTREGA:</h4>
          <div style="margin: 2rem 0 5rem 1.5rem; width: 50%">
            <div>
              <span style="margin-right: 1.1rem;" class="fonts-bold-general">Fecha de Pedido:</span>
              <el-date-picker
                v-model="day"
                type="date"
                format="dd/MM/yyyy"
                size="small"       
                style="width: 30%"
                >
              </el-date-picker>
            </div>  
          </div>     
      </div>
      <hr>
      <!-- SECCION DE PEDIDOS REALIZADOS-->
        <div style="margin: 2rem 3rem 6rem">
          <h4 style="margin: 5rem 0 3rem" class="text-orange"> PEDIDO REALIZADO</h4> 
           <!--CONTAINER  -->
          <div v-for="(item,index) in orders" :key="index">  
          <!-- BOTONES PARA INGRESAR NUEVOS CARDS Y IMG DEL TACHITO -->
            <el-row style="margin:2rem 0rem">
              <el-col :span="2" :offset="18" v-if="item._id===undefined || item._id===null">
                <el-button :disabled="orders[0].numberOrder==''" @click="newOrder(item)" type="primary">AÑADIR SOPORTE</el-button>                          
              </el-col>
              <el-col v-if="index!==0" :span="1" :offset="3">
                <img @click="deleteSupport(index)" src="../../../assets/images/basura-2.svg" alt="basura" width="33">
              </el-col>
            </el-row> 
            
           <!-- CARDS-->
            <el-row>
              <el-col style="margin-bottom: 4rem">
                <el-card class="bg-gray">
                  <el-row :gutter="20">
                    <el-col :span="12">
                      <div style="margin: 2rem 0 0 2.5rem">
                        <h4 class="text-navy-blue" style="margin-bottom:2rem">DETALLES DEL PEDIDO </h4>
                        <el-row style="margin-bottom: 1rem">
                          <el-col :span="12">
                            <span class="fonts-bold-general">Número de Pedido:<br></span> 
                          </el-col>
                          <el-col :span="10">
                            <el-input size="small" v-model="item.numberOrder"></el-input>
                          </el-col>
                        </el-row>
                        <el-row style="margin-bottom: 1rem">
                          <el-col :span="12">
                            <span  class="fonts-bold-general">Soporte de Pedido:<br></span> 
                          </el-col>
                          <el-col :span="10">
                           <el-select @change="verificarCorrelativo(item)" size="small" v-model="item.orderSupport" placeholder="Select">
                              <el-option
                                v-for="suport in suportOptions"
                                :key="suport.value"
                                :label="suport.label"
                                :value="suport.value">
                              </el-option>
                            </el-select>
                          </el-col>
                        </el-row>
                        <el-row style="margin-bottom: 1rem">
                          <el-col :span="12">
                            <span class="fonts-bold-general">Cantidad de Discos Pedidos:<br></span> 
                          </el-col>
                          <el-col :span="4">
                            <el-input size="small" v-model="item.quantity" @change="isPositiveValue(item)" type="Number"></el-input>
                          </el-col>
                        </el-row>          
                        <el-row v-if="item._id===undefined || item._id===null">
                          <el-col :span="12"><span class="fonts-bold-general">Ingrese correlativo</span></el-col>
                          <el-col :span="4"><el-input @change="verificarCambioCorrelativo(item)" size="small" v-model="item.correlative" type="Number"></el-input></el-col>                          
                        </el-row>              
                      </div>
                    </el-col>
                    <!-- CARDS DE LA DERECHA -->
                    <el-col :span="10" style="border-left:1px solid var(--color-grey-darken-2)">
                      <div style= "padding: 2rem 0 0rem 2.5rem">
                        <div class="line-heigth">
                           <h4 class="text-navy-blue" style="margin-bottom:2rem"> IMPORTE </h4>
                          <el-row style="margin-bottom: 1rem">
                            <el-col :span="12">
                              <span class="fonts-bold-general">Moneda<br></span> <span class="font-general" ></span>
                            </el-col>
                            <el-col :span="12" >
                              <!-- <el-select size="small" v-model="item.currency" placeholder="Select">
                                <el-option
                                  v-for="item in moneda"
                                  :key="item.value"
                                  :label="item.label"
                                  :value="item.value">
                                </el-option>
                              </el-select> -->
                              <!-- "SOLES" -->
                              <el-input v-model="item.currency" size="small" disabled></el-input>
                            </el-col>
                          </el-row>              
                          <el-row style="margin-bottom: 1rem">
                            <el-col :span="12">
                              <span class="fonts-bold-general">Importe Unitario<br></span>                        
                            </el-col>
                            <el-col :span="12">
                              <el-input v-model="item.unitaryImport" size="small" type='Number'></el-input>
                            </el-col>
                          </el-row>    
                          <el-row style="margin-bottom: 3rem">
                            <el-col :span="12">
                              <span class="fonts-bold-general">Importe Total<br></span>                         
                            </el-col>
                            <el-col :span="12">
                               <el-input :value="(item.quantity || 0 ) * (item.unitaryImport || 0) " size="small" disabled></el-input>
                            </el-col>
                          </el-row>  
                        </div>                       
                      </div>
                    </el-col>
                  </el-row>                
                </el-card>
              </el-col>              
            </el-row>
          </div>  
            <!-- TOTAL DEL PEDIDO- ULTIMA SECCION  -->
          <hr>
          <div  style="margin: 2rem 3rem 6rem">
             <h4 style="margin: 5rem 0 0" class="text-orange">IMPORTE TOTAL DEL PEDIDO</h4>
             <div style="margin: 2rem 0 5rem 1.5rem; width: 50%">
               <el-row style="margin-bottom: 1rem">
                  <el-col :span="12">
                    <span class="fonts-bold-general">Total del Pedido Realizado<br></span>                        
                  </el-col>
                  <el-col :span="12">
                    <el-input v-model="importTotalOrder"  size="small"></el-input>
                  </el-col>
                </el-row> 
            </div>     
          </div>
        </div>
        <!-- BOTONES DE REGISTRAR Y CANCELAR -->
        <el-row style="margin: 2rem 3rem 6rem">
          <el-col :span="2" :offset="17">
            <el-button @click="modalCancelButton = true" type="primary" size="medium" plain>CANCELAR </el-button>                          
          </el-col>
          <el-col :span="1" :offset="2">
            <el-button @click="enterNewOrder" type="primary" size="medium" :disabled="isInCompleteInfo">REGISTRAR</el-button>  
          </el-col>
        </el-row>  
    </section>

    <!-- Modal botón cancelar -->
    <AppModalDanger :show-dialog.sync="modalCancelButton" 
      v-if="modalCancelButton"  
      v-on:btnEvent="returnPage"  
      @btnEvent="modalCancelButton = false" 
      v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger>

    <!-- Modal botón ingresar-->
    <AppModalSuccess :show-dialog.sync="enterSupportModal" v-if="enterSupportModal" :styleModal="true"
      :parrafo="'El pedido <strong></strong> se ha registrado. <br>  Estara como pendiente hasta que ingreses la fecha de recepcion. ' "
      btn1="VER PEDIDOS" v-on:btnEvent="enterSupportModal = false" @btnEvent="returnPage" btn2="NUEVO PEDIDO" @eventBtn="enterSupportModal = false" v-on:eventBtn="clean">
    </AppModalSuccess>

     <!-- Modal botón borrar -->
     <AppModal :show-dialog.sync="modalDeleteSupport" v-if="modalDeleteSupport" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
      :parrafo="'¿Estas seguro que quieres eliminar la inforamción del pedido?'" btn1="SI, ELIMINAR" btn2="CANCELAR" classBtn1="border-red" typeBtn1="danger"
        @btnEvent="deleteOrder"
        v-on:eventBtn="modalDeleteSupport = false" >
    </AppModal>

    <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger parrafo="Si te vas sin guardar, la información se perderá." :show-dialog.sync="modalReturnBtn" v-if="modalReturnBtn"  v-on:btnEvent="returnPage" v-on:eventBtn="modalReturnBtn = false">
    </AppModalDanger> 

  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import { HTTP } from '@/main.js'
import moment from 'moment'
moment.locale('es');

export default {
  components: {
    ReturnButton,
    AppModalDanger,
    AppModalSuccess,
    AppModal
  },
  data() {
    return {
      orders:[],
      templateData:{
        numberOrder:'',
        orderSupport:'',
        quantity: '',
        correlative: '',
        currency:'Soles',
        unitaryImport:'',
      },
      modalDeleteSupport: false,
      modalReturnBtn: false,
      indexItem: 0,
      day: '',
      moneda: [
        {value: 'SOLES',label: 'Soles'}
      ],
      modalCancelButton: false,
      enterSupportModal: false,
      suportOptions: [
        {
          value: 'XD CAM 50 - GB',
          label: 'XD CAM 50 - GB'
        },
        {
          value: 'XD CAM 23 - GB',
          label: 'XD CAM 23 - GB'
        },
        {
          value: 'DISCO OPTICO 1.5 Tb',
          label: 'DISCO OPTICO 1.5 Tb'
        }
      ],
      isInCompleteInfo: true
    }
  },
  methods: {
    isPositiveValue(item) {
      let lastCorrelative = Number(item.quantity) + Number(item.correlative)-1
      let year = this.getYearSelect(this.day)
      HTTP.post('supports/verificatedElement',{orderSupport:item.orderSupport, year, quantity: item.quantity, lastPosCorrelative: lastCorrelative, element: Number(item.correlative), elementMin: Number(item.minCorrelative)})
      .then(res=>{
        item.quantity = res.data
      })
    },
    deleteSupport (index) {
      this.indexItem = index
      this.modalDeleteSupport = true
    },  
    clean () { 
      this.day = ''
      this.orders = [this.templateData]
    },
    returnPage () {
      localStorage.removeItem('objEditSupport');
      this.$router.push({ name: 'ordersPlaced' })
    },
    viewListMaterials () {
      this.$router.push({ name: "ordersPlaced" });
    },
    newOrder (item, index) {
      this.orders.push(JSON.parse(JSON.stringify(this.templateData)));
      this.calcularNumerosPedidos();
    },
    deleteOrder () {
      this.orders.splice(this.indexItem, 1)
      this.calcularNumerosPedidos();
      this.modalDeleteSupport = false
    },
    async enterNewOrder () {
      let isEdit = this.orders.filter(el=>el._id!==undefined && el._id!==null).length;
      if(isEdit>0){
        this.orders.forEach( async el=>{
          let payload = {
            quantity: el.quantity,
            orderSupport: el.orderSupport,
            dateOfOrder: this.day,
            currency: el.currency.toUpperCase(),
            numberOrder: el.numberOrder,
            unitaryImport: el.unitaryImport,
            year: this.getYearSelect(this.day),
          }
          await HTTP.patch('supports/'+el._id,payload);
        })
        this.enterSupportModal = true;
      }else{
        this.orders.forEach( async el=>{
          let payload = {
            initialCorrelative: el.correlative,
            quantity: el.quantity,
            orderSupport: el.orderSupport,
            dateOfOrder: this.day,
            currency: el.currency.toUpperCase(),
            numberOrder: el.numberOrder,
            unitaryImport: Number(el.unitaryImport),
            year: this.getYearSelect(this.day),
          }
          console.log(payload, 'post')
          await HTTP.post('supports',payload);
        })
        this.enterSupportModal = true;
      }
    },
    calcularNumerosPedidos(){
      let numeroPedido = this.orders[0].numberOrder.split('-')[0];
      if(this.orders.length==1) return this.orders[0].numberOrder = numeroPedido;
      this.orders.forEach((el,index)=>el.numberOrder = `${numeroPedido}-${index+1}`);
    },
    verificarCorrelativo(item){
      let year = this.getYearSelect(this.day)
      HTTP.post('supports/correlative',{orderSupport:item.orderSupport, year})
      .then(res=>{
        if(res.data.length==0){
          item.correlative    = '01';
          item.minCorrelative = '01';
        } else {
          const doc = res.data[0].codByOrder;
          item.correlative = this.creacionDelCorrelativo(doc);
          item.minCorrelative = this.creacionDelCorrelativo(doc);
        }
      })
      
    },
    creacionDelCorrelativo(doc) {
      let element  = parseInt( doc[doc.length - 1].split('/')[1] ) + 1
      if(element < 10 && element > 0) {
        return '0' + element
      } else {
        return String(element)
      }
    },
    verificarCambioCorrelativo(item){
      let year = this.getYearSelect(this.day)
      HTTP.post('supports/verificatedElement',{orderSupport:item.orderSupport, year, element: Number(item.correlative), elementMin: Number(item.minCorrelative)})
      .then(res=>{
        item.correlative = res.data
      })
      this.isPositiveValue(item)
    },
    getYearSelect(day) {
      let daySelect = !day || day == '' ? new Date() : day
      return moment(daySelect).year()
    }
  },
  computed: {
    importTotalOrder () {
      let total = 0
      this.orders.map(el => {
        total += (el.quantity || 0 ) * (el.unitaryImport || 0);
      })
      return total
    },
    visorElement() {
      let subElement = this.orders.map((e) => {
        const {numberOrder, orderSupport, quantity} = e
        return {numberOrder, orderSupport, quantity}
      })

      const elem = [
        this.day,
        this.orders[0]
      ].join()
      // return elem
      return this.orders
    }
  },
  watch: {
    day(val) {
      let element = this.orders
      element.map((e) => {
        if(e.orderSupport !== '') {
          this.verificarCorrelativo(e)
        }
      })
    },
    visorElement(val) {
      let subElement = []
      this.orders.map((e) => {
        const {numberOrder, orderSupport, quantity} = e
        if(numberOrder == '' ||orderSupport == '' ||quantity == '') {
          subElement.push( {numberOrder, orderSupport, quantity})
        }
      })
      if(subElement.length > 0 || (this.day == '' || this.day == null)) {
        this.isInCompleteInfo = true
      } else {
        this.isInCompleteInfo = false
      }
    }
  },
  created () {
    if(localStorage.getItem('objEditSupport')){
      this.orders.push(JSON.parse(localStorage.getItem('objEditSupport')));
      this.day = this.orders[0].dateOfOrder;
    }else{
      this.orders.push(JSON.parse(JSON.stringify(this.templateData)));
    }
  }
}

</script>
